* Compare LLFF with StrToFile()
#DEFINE PASSES 100

LOCAL cFileName, cContents, nHandle
LOCAL nPass, nSTart, nEnd

cFileName = FORCEPATH("TestOutput.TXT", SYS(2023))
SET SAFETY OFF 

SET ALTERNATE TO StrToFileTiming.TXT
SET ALTERNATE ON 

FOR nLength = 1 TO 10
	cContents = REPLICATE("Now is the time for all good men to come to the aid of their country." ;
	                      + CHR(13) + CHR(10), 1000 * m.nLength)
	                      
	? "Length of test string: ", LEN(m.cContents)

	* For LLFF, have to create file and then send a bit at a time
	nStart = SECONDS()
	FOR nPass = 1 TO PASSES
		nHandle = FCREATE(m.cFileName)
		IF m.nHandle <> -1
			nResult = FWRITE(m.nHandle, m.cContents, LEN(m.cContents))
		ENDIF
		FCLOSE(m.nHandle)
	ENDFOR 
	nEnd = SECONDS()

	? " With LLFF, characters written: ", m.nResult
	? " Total time: ", m.nEnd - m.nStart

	* For StrToFile(), one line
	nStart = SECONDS()

	FOR nPass = 1 TO PASSES
		nResult = STRTOFILE(m.cContents, m.cFileName, .F.)
	ENDFOR 
	nEnd = SECONDS()

	? " With STRTOFILE(), characters written: ", m.nResult
	? " Total time: ", m.nEnd - m.nStart
	
	* Try StrToFile() in loop, if past the magic number
	IF LEN(m.cContents) > 327680
		LOCAL nPart, cPart
		nStart = SECONDS()

		FOR nPass = 1 TO PASSES
			DELETE FILE (m.cFileName)
			FOR nPart = 1 TO CEILING(LEN(m.cContents)/327680)
				cPart = SUBSTR(m.cContents, (nPart-1) * 327680 + 1, 327680)
				nResult = STRTOFILE(m.cPart, m.cFileName, .T.)
			ENDFOR 
		ENDFOR 
		nEnd = SECONDS()

		? " With STRTOFILE() in a loop, characters written: ", m.nResult
		? " Total time: ", m.nEnd - m.nStart
	ENDIF 
ENDFOR 

SET ALTERNATE off
SET ALTERNATE TO 
SET SAFETY ON 
